#include <vga.h>

#define WHITE   15
#define BLACK   0
#define LTGRAY  7
#define DRGRAY  8

int draw_border(int x, int y, int w, int h, int t) {
	int r, c;

	for ( r = 0 ; r < h ; r++ ) {
		for ( c = 0 ; c < w ; c++ ) {
			if ( r == 0 || c == 0 || ( r == h-(t+1) && ( c > t && c < w-(t) ) ) || ( c == w-(t+1) && ( r > t && r < h-(t+1) ) ) ) { 
				vga_setcolor(WHITE);
			}

			else if ( r == h-1 || c == w-1 || ( r == t && ( c > t-1 && c < w-(t) ) ) || ( c == t && ( r > t && r < w-(t) ) ) ) {
				vga_setcolor(DRGRAY);
			}

			else if ( r < t || r > h-(t+1) || c < t || c > w-(t+1) ) {
				vga_setcolor(LTGRAY);
			}

			else vga_setcolor(BLACK);

			vga_drawpixel(x+c,y+r);
		}
	}

	return(0);
}

int draw_box(int x, int y, int w, int h) {
	int r, c;

	for ( r = 0 ; r < h ; r++ ) {
		for ( c = 0 ; c < w ; c++ ) {
			if ( r == 0 || c == 0 ) {
				vga_setcolor(WHITE);
			}

			else if ( r == h-1 || c == w-1 ) {
				vga_setcolor(DRGRAY);
			}

			else vga_setcolor(LTGRAY);

			vga_drawpixel(x+c,y+r);
		}
	}

	return(0);
}

int draw_button(char * string, int x, int y) {
	draw_box(x, y, get_vwf(string)+7, 16+7);

	draw_string(string,x+5,y+5,BLACK,0);
	draw_string(string,x+4,y+4,WHITE,0);
}

int draw_window(char * title, int x, int y, int w, int h) {
	draw_button(title,x,y);
	draw_border(x, y+23, w, h+4, 2);
	return(0);
}
	
int draw_get(char * title, char * output, int x, int y, int max) {
	draw_window(title,x,y,max*dw,22);
	return(get_string(output,x+4,y+23+4,max));
}

